unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, ScktComp;

type
  Twebio_ascii_client = class(TForm)
    gb_io: TGroupBox;
    cb_input0: TCheckBox;
    cb_input1: TCheckBox;
    cb_output0: TCheckBox;
    cb_output1: TCheckBox;
    lb_counter0: TLabel;
    lb_counter1: TLabel;
    ed_counter0: TEdit;
    ed_counter1: TEdit;
    bt_counter_read0: TButton;
    bt_counter_read1: TButton;
    bt_counter_clear0: TButton;
    bt_counter_clear1: TButton;
    bt_counter_readall: TButton;
    bt_counter_clearall: TButton;
    lb_counterall: TLabel;
    bt_inputs_read: TButton;
    bt_outputs_read: TButton;
    cb_output_polling: TCheckBox;
    cb_input_polling: TCheckBox;
    cb_counter_polling: TCheckBox;
    Label1: TLabel;
    ed_interval: TEdit;
    gb_connection: TGroupBox;
    Label2: TLabel;
    ed_ip: TEdit;
    ed_port: TEdit;
    bt_connect: TButton;
    bt_disconnect: TButton;
    StatusBar1: TStatusBar;
    ClientSocket1: TClientSocket;
    timer_polling: TTimer;
    ed_password: TEdit;
    lb_port: TLabel;
    lb_password: TLabel;
    procedure bt_connectClick(Sender: TObject);
    procedure bt_disconnectClick(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Connecting(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure cb_outputMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bt_outputs_readClick(Sender: TObject);
    procedure bt_inputs_readClick(Sender: TObject);
    procedure bt_counter_readClick(Sender: TObject);
    procedure bt_counter_clearClick(Sender: TObject);
    procedure bt_counter_readallClick(Sender: TObject);
    procedure bt_counter_clearallClick(Sender: TObject);
    procedure timer_pollingTimer(Sender: TObject);
    procedure ed_intervalChange(Sender: TObject);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  webio_ascii_client: Twebio_ascii_client;

implementation

{$R *.DFM}

function HexToInt(HexString : String) : longWord;
var CharCount           : integer;
    HexCharValue        : longWord;
    HexValue            : longWord;
begin
   HexValue := 0;
   HexString := UpperCase(HexString);
   for CharCount := 1 to length(HexString) do
   begin
     HexCharValue := ord(HexString[CharCount]);
     if HexCharValue > 57 then
        HexCharValue := HexCharValue - 55
     else
        HexCharValue := HexCharValue - 48;
     HexCharValue := HexCharValue shl ((length(HexString) - CharCount) *  4);
     HexValue := HexValue or HexCharValue;
   end;
   HexToInt := HexValue;
end;

procedure Twebio_ascii_client.bt_connectClick(Sender: TObject);
begin
  if ed_ip.Text <> '' then
  begin
    ClientSocket1.Host := ed_ip.Text;
    ClientSocket1.Port := strtoint(ed_port.Text);
    ClientSocket1.Active := True;
  end;  
end;

procedure Twebio_ascii_client.bt_disconnectClick(Sender: TObject);
begin
  ClientSocket1.Active := False;
end;

procedure Twebio_ascii_client.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar1.SimpleText := 'Connected to ' + ed_ip.Text;
  bt_connect.Enabled := False;
  bt_disconnect.Enabled := True;
  gb_io.Enabled := True;
end;

procedure Twebio_ascii_client.ClientSocket1Connecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  StatusBar1.SimpleText := 'Try to connect to ' + ed_ip.Text;
  bt_connect.Enabled := False;
end;

procedure Twebio_ascii_client.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  ClientSocket1.Active := False;
  StatusBar1.SimpleText := 'No Connection';
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

procedure Twebio_ascii_client.ClientSocket1Error(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  ClientSocket1.Active := False;
  StatusBar1.SimpleText := 'Error ' + inttostr(ErrorCode) + ' - No Connection';
  ErrorCode := 0;
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

procedure Twebio_ascii_client.cb_outputMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if sender = cb_output0 then
    if cb_output0.Checked then
      ClientSocket1.Socket.
         SendText('GET /outputaccess0?PW=' + ed_password.Text + '&State=ON&')
    else
      ClientSocket1.Socket.
         SendText('GET /outputaccess0?PW=' + ed_password.Text + '&State=OFF&')
  else
    if cb_output1.Checked then
      ClientSocket1.Socket.
         SendText('GET /outputaccess1?PW=' + ed_password.Text + '&State=ON&')
    else
      ClientSocket1.Socket.
         SendText('GET /outputaccess1?PW=' + ed_password.Text + '&State=OFF&');
end;

procedure Twebio_ascii_client.bt_outputs_readClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /output?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_inputs_readClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /input?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counter_readClick(Sender: TObject);
begin
  if sender = bt_counter_read0 then
    ClientSocket1.Socket.SendText('GET /counter0?PW=' + ed_password.Text + '&')
  else
    ClientSocket1.Socket.SendText('GET /counter1?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counter_clearClick(Sender: TObject);
begin
  if sender = bt_counter_clear0 then
    ClientSocket1.Socket.
        SendText('GET /counterclear0?PW=' + ed_password.Text + '&')
  else
    ClientSocket1.Socket.
        SendText('GET /counterclear1?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.bt_counter_readallClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /counter?PW=' + ed_password.Text + '&')
end;

procedure Twebio_ascii_client.bt_counter_clearallClick(Sender: TObject);
begin
  ClientSocket1.Socket.
      SendText('GET /counterclear?PW=' + ed_password.Text + '&')
end;

procedure Twebio_ascii_client.timer_pollingTimer(Sender: TObject);
begin
  if ClientSocket1.Active and cb_output_polling.Checked then
    ClientSocket1.Socket.SendText('GET /output?PW=' + ed_password.Text + '&');
  if ClientSocket1.Active and cb_input_polling.Checked then
    ClientSocket1.Socket.SendText('GET /input?PW=' + ed_password.Text + '&');
  if ClientSocket1.Active and cb_counter_polling.Checked then
    ClientSocket1.Socket.SendText('GET /counter?PW=' + ed_password.Text + '&');
end;

procedure Twebio_ascii_client.ed_intervalChange(Sender: TObject);
begin
  timer_polling.Interval := strtoint(ed_interval.Text);
end;

procedure Twebio_ascii_client.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var ReceiveString : String;
    SemiPosition : integer;
    OutputValue : word;
    InputValue : word;
begin
  ReceiveString := ClientSocket1.Socket.ReceiveText;
  if Receivestring[1] = 'o' then
  begin
    OutputValue := HextoInt(copy(ReceiveString,
     pos(';',ReceiveString)+1,length(ReceiveString)-pos(';',ReceiveString)-1));
    if OutputValue and 1 = 1 then
      cb_output0.Checked := True
    else
      cb_output0.Checked := False;
    if OutputValue and 2 = 2 then
      cb_output1.Checked := True
    else
      cb_output1.Checked := False;
  end;
  if Receivestring[1] = 'i' then
  begin
    InputValue := HextoInt(copy(ReceiveString,
       pos(';',ReceiveString)+1,
       length(ReceiveString)-pos(';',ReceiveString)-1));
    if InputValue and 1 = 1 then
      cb_input0.Checked := True
    else
      cb_input0.Checked := False;
    if InputValue and 2 = 2 then
      cb_input1.Checked := True
    else
      cb_input1.Checked := False;
  end;
  if Receivestring[1] = 'c' then
  begin
    if copy(ReceiveString, 8, 1) = '0' then
      ed_counter0.Text := copy(ReceiveString, 10,length(ReceiveString)-10);
    if copy(ReceiveString, 8, 1) = '1' then
      ed_counter1.Text := copy(ReceiveString, 10,length(ReceiveString)-10);
    if copy(ReceiveString, 8, 1) = ';' then
    begin
      ReceiveString[8] := ' ';
      ed_counter0.Text := copy(ReceiveString, 9, pos(';',ReceiveString)-9);
      ed_counter1.Text := copy(ReceiveString,
        pos(';',ReceiveString)+1,
        length(ReceiveString)-pos(';',ReceiveString)-1);
    end;
  end;  
end;

procedure Twebio_ascii_client.FormCreate(Sender: TObject);
begin
  StatusBar1.SimpleText := 'No Connection';
  bt_disconnect.Enabled := False;
  gb_io.Enabled := False;
end;

end.
